<!DOCTYPE html>
<html>
    <body>
        <script>
            //declaring an object
            var obj1={
                name:"swetha",
                age:21,
                details : function(){return this.name;},
                ofc_det : {ofc_name:"Techigai",empid:2379},
                1:1,
                name:"lohitha", //duplicate property-this value overwrites the 1st name value
            }
            //accessing properties of an object
            x="name";
            document.write(obj1.name+"</br>");
            document.write(obj1["name"]+"</br>");
            document.write(obj1["name"]+"</br>");
            //accesing functions in an object
            document.write(obj1.details()+"</br>");
            document.write(obj1["details"]()+"</br>");
            //object can also have ingers as keys
            document.write(obj1[1]+"</br>");
            //objects with in the object
            document.write(obj1.ofc_det.ofc_name+"</br>");
            
            //retreiving all keys of an object
            var keys=Object.keys(obj1);
            document.write(keys+"</br>");

            //retreiving all values of an object
            var values=Object.values(obj1);
            document.write(values+"</br>");
            
            //THIS
            var var1=10;
            function f1()
            {
               var var1=20;
               document.write("var1 = "+var1+"</br>");
               document.write("this = "+this+"</br>");
               document.write("this.var1 = "+this.var1+"</br>");

            }
            document.write("</br>Calling from window</br>");
            f1();//here f1 is called from window object hence this refers window
            document.write("</br>Calling from object without var1</br>");
            var obj_f1=new f1();//here obj_f1 doesn't have var1 variable
             
            function f2()
            {
                this.var1=30;
                this.f21=function()
                {
                    document.write("var1 = "+var1+"</br>");
                    document.write("this = "+this+"</br>");
                    document.write("this.var1 = "+this.var1+"</br>"); 
                }
            }
            document.write("</br>Calling from object with var1</br>");
            var obj_f2=new f2();
            obj_f2.f21();
            var obj3={
                name:"swetha"
            }
            obj3.name="lohitha";
            document.write(obj3.name+"</br>");

            var obj4={
                first_name:"swetha",
                last_name:"kolla"
            }
            obj4.name=function (){return this.first_name+this.last_name;}
            document.write(obj4.name()+"</br>");
            document.write("obj4 properties : "+Object.getOwnPropertyNames(obj4)+"</br>"); //property names
            document.write("obj4 keys : "+Object.keys(obj4)+"</br>"); //keys of an object
            document.write("obj4 values : "+Object.values(obj4)+"</br>"); //property values of an objects
            var entries=Object.entries(obj4);
            document.write("obj4 entries</br>");
            for(i of entries)
            {
                document.write(i+"</br>");//nested array of the key/value pairs of an object.
            }
            var obj5=Object.assign(obj4);
            obj4.age=21;
            obj4.first_name="lohitha";
            console.log(obj4);
            console.log(obj5);
            obj5.age=22;
            obj5.first_name="lohitha1";
            console.log(obj4);
            console.log(obj5);
            //assign for object merging
            var obj6={fname:"swetha"};
            var obj7={lname:"kolla"};
            var obj8=Object.assign(obj6,obj7);
            console.log("obj7 "+obj7);
            console.log(obj8);
            obj8.fname="lohitha";
            console.log("1st");
            console.log(obj6);
            console.log(obj7);
            console.log(obj8);
            obj8.fname="lohitha1";
            console.log("2nd");
            console.log(obj6);
            console.log(obj7);
            console.log(obj8);

            //defineProperty
            Object.defineProperty(obj8,'mname',{value:"Guna",writable:true,configurable:true});//if writable is false we can't performe any operation on mname in obj8
            delete obj8.mname;
            console.log("after")
            console.log(obj8);
            obj8.mname="naga";
            console.log(obj8);

            Object.defineProperties(obj8, {"age" : {value:22,writable:true}, 
                                            "num" : {value:123,writable:false}})
            
            console.log(obj8);

             Object.freeze(obj8);
            obj8.mname="sai";//mname doesn't change
            console.log(obj8);
            
            var obj11={name:"swetha",inner:{ab:20}};
            Object.freeze(obj11);
            obj11.name="Lohitha";//can't change the property
            obj11.inner.ab=23;//can change the child object properties 
            console.log("obj11-name"+obj11.name);
            console.log("obj11_inner"+obj11.inner.ab);
            var arr1=new Map([["name",{"fname":"swetha","lname":"kolla"}],["age",27]]);
            var obj9=Object.fromEntries(arr1);
            console.log(obj9);

            //getter and setter
            var obj10={
                fname:"swetha",
                lname:"kolla",
                        get fullname(){
                            return this.fname+this.lname;
                        },
                    set fullname(name1){[this.fname,this.lname]=name1.split(" ");}};
            console.log(obj10.fullname);
            obj10.name="lohitha kolla";
            console.log(obj10.name);
            Object.assign(obj10,obj11);
            console.log(obj10);
            obj10.name="lohitha";
            console.log(obj10.name);
            
            //factory functions
            function details(fname,mname,lname)
            {
                return{
                fname,
                lname,
                mname
                }
            }
            var per1=details("swetha","guna","kolla");
            console.log(per1);
            var per2=details("lohitha","srei sai","kolla");
            console.log(per2);

            //PROMISES
            console.log("PROMISE")
            var p=new Promise((res,rej)=>
            {
                var a=0;
                if(a==1)
                {
                    
                    res(a*2);
                }
                else
                {
                    rej(a);
                }
            }
            )
            p.then((msg)=>{console.log(msg);}).catch((msg)=>{console.log(msg);}).catch((msg)=>{console.log("1st");console.log(msg);})

            //promise.all
            var p1=new Promise((resolve,reject)=>{
                reject("Promise1 resolved");
            });
            var p2=new Promise((resolve,reject)=>{
                reject("Promise2 resolved");
            });
            var p3=new Promise((resolve,reject)=>{
                reject("Promise3 resolved");
            });
            Promise.all([p1,p2,p3]).then((messages)=>{console.log(messages)},
                (messages)=>{console.log(messages)});

            //Promise.reject()
            //.then(() => 99, () => 42,()=>43) // onRejected returns 42 which is wrapped in a resolving Promise
            //.then(solution => console.log('Resolved with ' + solution));
            
            //CHAINING THEN
            /*var p4=new Promise((resolve,reject)=>{ resolve(4);});
            p4
            .then((value)=>{alert(value);return value*2;})
            .then((value)=>{alert(value);return value*2;})
            .then((value)=>{alert(value);return value*2;})
            .then((value)=>{alert(value);return value*2;})
            console.log("PROMISE2");*/
            var p5=new Promise((resolve,reject)=>{
                resolve("resolved");});
               // reject("rejected");}); 
            p5.then(
                msg=>console.log(msg+" 1st"),
                    msg=>console.log(msg+"2nd"))
                .catch(msg=>console.log(msg+"catch1"));
            p5.then(msg=>console.log(msg+" 21st"))//.then may be called more than once on same promise
                .catch(msg=>console.log(msg+"catch21"));

            // var p6=new Promise(function(resolve,reject){resolve("resolve_chain");})
            // .then((x)=> {return p7;})
            // .then((x)=>{console.log(x);});
            var p7=new Promise((resolve,reject)=>{resolve("resolve7_chain");});
            p7.then((x)=>{console.log("solved")
                            throw(new Error("Oh no!"))}).catch(error=>console.log(error));
promises_createThenRun();
function promises_createThenRun() {
  const p1 = createPromise1();
  const p2 = createPromise2();

  console.log('before hello');
  alert('hello');
  console.log('after hello');
  // the two promises run at this point.  What makes them run?
}

function createPromise1() {
  let p1 = new Promise((resolve, reject) => {
    window.setTimeout(() => {
      console.log('timer 1');
      //resolve();
    }, 2000);
  });
  return p1;
}

function createPromise2() {
  let p2 = new Promise((resolve, reject) => {
    window.setTimeout(() => {
      console.log('timer 2');
      //resolve();
    }, 1000);
  });
  return p2;}

  var pr1=new Promise((res,rej)=>{console.log("in pr1")});

  var ob1={a:1,b:2};
  Object.freeze(ob1);
  var obj10={c:3,d:4};
  ob1=obj10;
  console.log(ob1);
//   var ob2=Object.assign({},ob1);
//   ob2.a=4;
//   ob2.a2=5;
//   ob1=Object.assign(ob2);
//   ob1.a1=3;
//   console.log(ob1);
// function prom()
// {
//     //new Promise(res=>{console.log("resolved")},rej=>{console.log("rejected")});
//     new Promise(resolve => {
//   setTimeout(() => resolve(888), 1000);
// })
// }

//prom();


          </script>
    </body>
</html>